/* $Id: ata_identify.c,v 1.1 2004/05/26 13:30:06 harald Exp $ */
#include <stdio.h>
#include <sys/ioctl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <errno.h>
#include <unistd.h>

#include <linux/types.h>
#include <linux/hdreg.h>

int main(int argc, char **argv)
{
	struct hd_driveid id;
	int fd, i, j, l, r;
	char unique[sizeof(id.model) + sizeof(id.serial_no) + 1];

	fd = open(argv[1], O_RDONLY | O_NONBLOCK);
	if (fd < 0) {
		perror(argv[0]);
		return 1;
	}

	if (!ioctl(fd, HDIO_GET_IDENTITY, &id)) {

		l = r = unique[sizeof(unique) - 1] = 0;

		for (j = sizeof(id.model); j >= 0; --j)
			if (id.model[j] && id.model[j] != ' ')
				break;
		for (i = 0; i < j; i++) {
			if (id.model[i] == ' ') {
				if (!l)
					continue;
				id.model[i] = '_';
			}
			if (!id.model[i])
				break;
			unique[r++] = id.model[i];
			l++;
		}
		l = 0;
		for (j = sizeof(id.serial_no); j >= 0; --j)
			if (id.serial_no[j] && id.serial_no[j] != ' ')
				break;
		if (id.serial_no[0] && id.serial_no[0] != ' ')
			unique[r++] = '_';
		for (i = 0; i < j; i++) {
			if (id.serial_no[i] == ' ') {
				if (!l)
					continue;
				id.serial_no[i] = '_';
			}
			if (!id.serial_no[i])
				break;
			unique[r++] = id.serial_no[i];
			l++;
		}
		unique[r] = '\0';
		printf("%s\n", unique);
	} else if (errno == -ENOMSG)
		fprintf(stderr, " no identification info available\n");
	else
		fprintf(stderr, " HDIO_GET_IDENTITY failed on %s\n", argv[1]);

	close(fd);
	return 0;
}
